package com.sun.jersey.samples.servlet3.annotatedapp;

//import com.sun.jersey.spi.container.servlet.ServletContainer;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;
import java.util.Enumeration;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.core.Application;

public class NewServlet extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
 //           find(ServletContainer.class);
            find(Application.class);
            find(ApplicationPath.class);
        } catch (Exception e) {
        }
        
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet NewServlet</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet NewServlet at " + request.getContextPath () + "</h1>");
            out.println("</body>");
            out.println("</html>");
        } finally { 
            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    private void find(Class c) {
        try {
            String path = c.getName().replace(".", "/") + ".class";
            System.out.println("FIND: " + c.getName() + " " + path);

            System.out.println("  Class loader of class");
            Enumeration<URL> e = c.getClassLoader().getResources(path);
            while (e.hasMoreElements()) {
                System.out.println("    " + e.nextElement().toExternalForm());
            }

            System.out.println("  Context class loader");
            e = Thread.currentThread().getContextClassLoader().getResources(path);
            while (e.hasMoreElements()) {
                System.out.println("    " + e.nextElement().toExternalForm());
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
